SystemOrganization addCategory: #LazyRabbit!

!Class methodsFor: '*LazyRabbit' stamp: 'hjo 12/4/2011 13:14'!
addLazyRabbitInstVarFromUser

	LazyRabbitControlledByUser addInstVarAndMethodsWithDefaultCodeTo: self.! !

TestResource subclass: #LazyRabbitTestResourceForController
	instanceVariableNames: 'subjectClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LazyRabbit'!

!LazyRabbitTestResourceForController methodsFor: 'as yet unclassified' stamp: 'hjo 12/4/2011 18:54'!
setUp

	super setUp.
	subjectClass := 
		Object 
			subclass: #LazyRabbitTestDummyForController
			instanceVariableNames: ''
			classVariableNames: ''
			poolDictionaries: ''
			category: 'LazyRabbitTestResources'.
! !

!LazyRabbitTestResourceForController methodsFor: 'accessing' stamp: 'hjo 12/4/2011 17:28'!
subjectClass

	^subjectClass! !

!LazyRabbitTestResourceForController methodsFor: 'as yet unclassified' stamp: 'hjo 12/4/2011 18:54'!
tearDown

	subjectClass removeFromSystem.
	super tearDown! !

TestResource subclass: #LazyRabbitTestResourceForModel
	instanceVariableNames: 'subjectClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LazyRabbit'!

!LazyRabbitTestResourceForModel methodsFor: 'as yet unclassified' stamp: 'hjo 12/4/2011 18:54'!
setUp

	super setUp.
	subjectClass := 
		Object 
			subclass: #LazyRabbitTestDummyForModel
			instanceVariableNames: ''
			classVariableNames: ''
			poolDictionaries: ''
			category: 'LazyRabbitTestResources'.
! !

!LazyRabbitTestResourceForModel methodsFor: 'accessing' stamp: 'hjo 8/22/2009 16:06'!
subjectClass

	^subjectClass! !

!LazyRabbitTestResourceForModel methodsFor: 'as yet unclassified' stamp: 'hjo 12/4/2011 18:55'!
tearDown

	subjectClass removeFromSystem.
	super tearDown! !

OBCommand subclass: #OBCmdLayzRabbitAddInstVar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LazyRabbit'!

!OBCmdLayzRabbitAddInstVar methodsFor: 'execution' stamp: 'hjo 12/4/2011 17:03'!
execute

	target theNonMetaClass addLazyRabbitInstVarFromUser! !

!OBCmdLayzRabbitAddInstVar methodsFor: 'accessing' stamp: 'hjo 12/4/2011 17:04'!
group

	^ #lazyRabbit! !

!OBCmdLayzRabbitAddInstVar methodsFor: 'testing' stamp: 'hjo 12/4/2011 17:03'!
isActive

	^ (target isKindOf: OBClassNode) and: [requestor isSelected: target]! !

!OBCmdLayzRabbitAddInstVar methodsFor: 'accessing' stamp: 'hjo 12/4/2011 17:03'!
label

	^ 'Add lazy inst var'! !

!OBCodeBrowser methodsFor: '*LazyRabbit' stamp: 'hjo 12/4/2011 17:00'!
lazyRabbitCommand
	<command>
	
	^ OBCmdLayzRabbitAddInstVar! !

TestCase subclass: #LazyRabbitControllerTest
	instanceVariableNames: 'rabbitController'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LazyRabbit'!

!LazyRabbitControllerTest classSide methodsFor: 'as yet unclassified' stamp: 'hjo 12/4/2011 17:31'!
resources

	^Array with: LazyRabbitTestResourceForController! !

!LazyRabbitControllerTest methodsFor: 'running' stamp: 'hjo 12/4/2011 23:19'!
setUp

	super setUp.
	rabbitController := LazyRabbitController new.
	rabbitController model subjectClass: self subjectClass
	
! !

!LazyRabbitControllerTest methodsFor: 'accessing' stamp: 'hjo 12/4/2011 17:31'!
subjectClass

	^LazyRabbitTestResourceForController current subjectClass! !

!LazyRabbitControllerTest methodsFor: 'inst var' stamp: 'hjo 12/4/2011 23:19'!
testAddInstVarAgainMakesError

	self deny: (self subjectClass instVarNames includes: 't').
	rabbitController model variableName: 't'.
	rabbitController model createInstanceVariable.
	self assert: (self subjectClass instVarNames includes: 't').

	"adding again here."	
	self should: [rabbitController model createInstanceVariable] raise: Error.
	self assert: (self subjectClass instVarNames includes: 't').! !

!LazyRabbitControllerTest methodsFor: 'browser' stamp: 'hjo 8/25/2009 22:28'!
testBrowserMenu

	self assert: (Browser canUnderstand: #createLazyRabbitVar).
	self deny: ((Browser sourceCodeAt: #shiftedClassListMenu:) asString indexOfSubCollection: 'createLazyRabbitVar') isZero! !

!LazyRabbitControllerTest methodsFor: 'hmm' stamp: 'hjo 12/4/2011 23:19'!
testCreateAllMethodsForSubjectClass

	| defaultSelectors instVars |
	rabbitController userWantsToOverwriteGetter: false.
	rabbitController userWantsToOverwriteSetter: false.
	rabbitController userWantsToOverwriteDefaultGenerator: false.

	(Array with: 'all1' with: 'all2' with: 'all3' with: 'all4') do:
		[:str| 	
			rabbitController model variableName: str.
			rabbitController model createInstanceVariable.
		].

	rabbitController createAllMethodsForSubjectClass.

	defaultSelectors := rabbitController model subjectClass selectors
		select: [:each| (rabbitController model subjectClass organization categoryOfElement: each) =#'defaults' ].
	
	instVars := rabbitController model subjectClass instVarNames.
	self assert: defaultSelectors size = instVars size! !

!LazyRabbitControllerTest methodsFor: 'scenarios' stamp: 'hjo 12/4/2011 23:19'!
testDefaultGeneratorAlreadyExistsAndUserDoesNotWantToOverwriteIt

	rabbitController model variableName: 'gogoG'.
	rabbitController model subjectClass compile: 
'defaultGogoG
	
	^8'.
	self deny: rabbitController model subjectClassHasInstanceVariableNamedVariableName.
	self deny: rabbitController model subjectClassHasGetter.
	self deny: rabbitController model subjectClassHasSetter.
	self assert: rabbitController model subjectClassHasDefaultGenerator.
	rabbitController userWantsToOverwriteDefaultGenerator: false.
	rabbitController tryToCreateVariableAndMethods.
	self assert: rabbitController model subjectClassHasInstanceVariableNamedVariableName.
	self assert: rabbitController model subjectClassHasGetter.
	self assert: rabbitController model subjectClassHasSetter.
	self assert: rabbitController model subjectClassHasDefaultGenerator.
	self assert: rabbitController model sourceCodeOfDefaultGeneratorMethod =
 'defaultGogoG
	
	^8'! !

!LazyRabbitControllerTest methodsFor: 'scenarios' stamp: 'hjo 12/4/2011 23:19'!
testDefaultGeneratorAlreadyExistsAndUserWantsToOverwriteIt

	rabbitController model variableName: 'gogoF'.
	rabbitController model subjectClass compile: 
'defaultGogoF
	
	^8'.
	self deny: rabbitController model subjectClassHasInstanceVariableNamedVariableName.
	self deny: rabbitController model subjectClassHasGetter.
	self deny: rabbitController model subjectClassHasSetter.
	self assert: rabbitController model subjectClassHasDefaultGenerator.
	rabbitController userWantsToOverwriteDefaultGenerator: true.
	rabbitController tryToCreateVariableAndMethods.
	self assert: rabbitController model subjectClassHasInstanceVariableNamedVariableName.
	self assert: rabbitController model subjectClassHasGetter.
	self assert: rabbitController model subjectClassHasSetter.
	self assert: rabbitController model subjectClassHasDefaultGenerator.
	self assert: rabbitController model sourceCodeOfDefaultGeneratorMethod =
 'defaultGogoF

	"Return a default object for instance variable gogoF."
	^self shouldBeImplemented'! !

!LazyRabbitControllerTest methodsFor: 'scenarios' stamp: 'hjo 12/4/2011 23:19'!
testEasyAndComfortPath

	rabbitController model variableName: 'gogoA'.
	self deny: rabbitController model subjectClassHasInstanceVariableNamedVariableName.
	self deny: rabbitController model subjectClassHasGetter.
	self deny: rabbitController model subjectClassHasSetter.
	self deny: rabbitController model subjectClassHasDefaultGenerator.
	rabbitController tryToCreateVariableAndMethods.
	self assert: rabbitController model subjectClassHasInstanceVariableNamedVariableName.
	self assert: rabbitController model subjectClassHasGetter.
	self assert: rabbitController model subjectClassHasSetter.
	self assert: rabbitController model subjectClassHasDefaultGenerator.
! !

!LazyRabbitControllerTest methodsFor: 'scenarios' stamp: 'hjo 12/4/2011 23:19'!
testGetterAlreadyExistsAndUserDoesNotWantToOverwriteIt

	rabbitController model variableName: 'gogoC'.
	rabbitController model subjectClass compile: 
'gogoC

	"do nothing"'.
	self deny: rabbitController model subjectClassHasInstanceVariableNamedVariableName.
	self assert: rabbitController model subjectClassHasGetter.
	self deny: rabbitController model subjectClassHasSetter.
	self deny: rabbitController model subjectClassHasDefaultGenerator.
	rabbitController userWantsToOverwriteGetter: false.
	rabbitController tryToCreateVariableAndMethods.
	self assert: rabbitController model subjectClassHasInstanceVariableNamedVariableName.
	self assert: rabbitController model subjectClassHasGetter.
	self assert: rabbitController model subjectClassHasSetter.
	self assert: rabbitController model subjectClassHasDefaultGenerator.
	self assert: rabbitController model sourceCodeOfGetterMethod =
'gogoC

	"do nothing"'! !

!LazyRabbitControllerTest methodsFor: 'scenarios' stamp: 'hjo 12/4/2011 23:19'!
testGetterAlreadyExistsAndUserWantsToOverwriteIt

	rabbitController model variableName: 'gogoB'.
	rabbitController model subjectClass compile: 
'gogoB

	"do nothing"'.
	self deny: rabbitController model subjectClassHasInstanceVariableNamedVariableName.
	self assert: rabbitController model subjectClassHasGetter.
	self deny: rabbitController model subjectClassHasSetter.
	self deny: rabbitController model subjectClassHasDefaultGenerator.
	rabbitController userWantsToOverwriteGetter: true.
	rabbitController tryToCreateVariableAndMethods.
	self assert: rabbitController model subjectClassHasInstanceVariableNamedVariableName.
	self assert: rabbitController model subjectClassHasGetter.
	self assert: rabbitController model subjectClassHasSetter.
	self assert: rabbitController model subjectClassHasDefaultGenerator.
	self assert: rabbitController model sourceCodeOfGetterMethod =
'gogoB

	^gogoB setDefault: #defaultGogoB for: self withSetter: #gogoB:'! !

!LazyRabbitControllerTest methodsFor: 'scenarios' stamp: 'hjo 12/4/2011 23:42'!
testIfUserWantsToQuitThenDoNothing

	rabbitController model variableName: 'gogoH'.
	rabbitController model compileAsAccessing:
'gogoH
	
	^8'.
	rabbitController model compileAsAccessing:
'gogoH: aString
	
	^7'.
	rabbitController model compileAsDefaults: 
'defaultGogoH
	
	^6'.

	rabbitController userWantsToQuit: true.
	rabbitController tryToCreateVariableAndMethods.

	self assert: rabbitController model sourceCodeOfGetterMethod =
'gogoH
	
	^8'.
	self assert: rabbitController model sourceCodeOfSetterMethod =
'gogoH: aString
	
	^7'.
	self assert: rabbitController model sourceCodeOfDefaultGeneratorMethod =
'defaultGogoH
	
	^6'.
	! !

!LazyRabbitControllerTest methodsFor: 'scenarios' stamp: 'hjo 12/4/2011 23:19'!
testSetterAlreadyExistsAndUserDoesNotWantToOverwriteIt

	rabbitController model variableName: 'gogoD'.
	rabbitController model subjectClass compile: 
'gogoD: anObject

	"do nothing"'.
	self deny: rabbitController model subjectClassHasInstanceVariableNamedVariableName.
	self deny: rabbitController model subjectClassHasGetter.
	self assert: rabbitController model subjectClassHasSetter.
	self deny: rabbitController model subjectClassHasDefaultGenerator.
	rabbitController userWantsToOverwriteSetter: false.
	rabbitController tryToCreateVariableAndMethods.
	self assert: rabbitController model subjectClassHasInstanceVariableNamedVariableName.
	self assert: rabbitController model subjectClassHasGetter.
	self assert: rabbitController model subjectClassHasSetter.
	self assert: rabbitController model subjectClassHasDefaultGenerator.
	self assert: rabbitController model sourceCodeOfSetterMethod =
'gogoD: anObject

	"do nothing"'.! !

!LazyRabbitControllerTest methodsFor: 'scenarios' stamp: 'hjo 12/4/2011 23:19'!
testSetterAlreadyExistsAndUserWantsToOverwriteIt

	rabbitController model variableName: 'gogoE'.
	rabbitController model compileAsAccessing: 
'gogoE: anObject

	"do nothing"'.
	self deny: rabbitController model subjectClassHasInstanceVariableNamedVariableName.
	self deny: rabbitController model subjectClassHasGetter.
	self assert: rabbitController model subjectClassHasSetter.
	self deny: rabbitController model subjectClassHasDefaultGenerator.
	rabbitController userWantsToOverwriteSetter: true.
	rabbitController tryToCreateVariableAndMethods.
	self assert: rabbitController model subjectClassHasInstanceVariableNamedVariableName.
	self assert: rabbitController model subjectClassHasGetter.
	self assert: rabbitController model subjectClassHasSetter.
	self assert: rabbitController model subjectClassHasDefaultGenerator.
	self assert: rabbitController model sourceCodeOfSetterMethod =
 'gogoE: anObject
		
	gogoE := anObject'! !

!LazyRabbitControllerTest methodsFor: 'default source code' stamp: 'hjo 12/4/2011 23:19'!
testUserEnteredDefaultExpression

	rabbitController userEnteredDefaultExpression: '100'.
	self assert: '100' equals: rabbitController model expressionForDefaultGenerator.! !

!LazyRabbitControllerTest methodsFor: 'default source code' stamp: 'hjo 12/4/2011 23:19'!
testUserEnteredEmptyStringForDefaultExpression

	rabbitController userEnteredDefaultExpression: ''.
	rabbitController model expressionForDefaultGenerator = '^self error'! !

TestCase subclass: #LazyRabbitModelTest
	instanceVariableNames: 'rabbit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LazyRabbit'!

!LazyRabbitModelTest classSide methodsFor: 'as yet unclassified' stamp: 'hjo 12/4/2011 17:31'!
resources

	^Array with: LazyRabbitTestResourceForModel! !

!LazyRabbitModelTest methodsFor: 'running' stamp: 'hjo 12/4/2011 17:28'!
setUp

	super setUp.
	rabbit := LazyRabbitModel new.
	rabbit subjectClass: self subjectClass! !

!LazyRabbitModelTest methodsFor: 'accessing' stamp: 'hjo 12/4/2011 17:31'!
subjectClass

	^LazyRabbitTestResourceForModel current subjectClass! !

!LazyRabbitModelTest methodsFor: 'compiling' stamp: 'hjo 12/4/2011 23:05'!
testCreateDefaultGeneratorMehtod

	rabbit variableName: 'cdgm'.
	self deny: rabbit subjectClassHasDefaultGenerator.
	rabbit createDefaultGeneratorMethod.
	self assert: rabbit subjectClassHasDefaultGenerator.
	self assert: (MethodReference class: rabbit subjectClass selector: rabbit defaultGeneratorSelector) category = #'defaults'! !

!LazyRabbitModelTest methodsFor: 'compiling' stamp: 'hjo 8/26/2009 19:45'!
testCreateGetterMethod

	rabbit variableName: 'cgm'.
	self deny: rabbit subjectClassHasGetter.
	rabbit createGetterMethod.
	self assert: rabbit subjectClassHasGetter.	
	self assert: (MethodReference class: rabbit subjectClass selector: rabbit getterSelector) category = #'accessing'! !

!LazyRabbitModelTest methodsFor: 'compiling' stamp: 'hjo 8/25/2009 22:17'!
testCreateInstanceVariable

	self deny: (self subjectClass instVarNames includes: 'yy').
	rabbit variableName: 'yy'.
	rabbit createInstanceVariable.
	self assert: (self subjectClass instVarNames includes: 'yy').! !

!LazyRabbitModelTest methodsFor: 'compiling' stamp: 'hjo 8/26/2009 19:43'!
testCreateSetterMethod

	rabbit variableName: 'csm'.
	self deny: rabbit subjectClassHasSetter.
	rabbit createSetterMethod.
	self assert: rabbit subjectClassHasSetter.	
	self assert: (MethodReference class: rabbit subjectClass selector: rabbit setterSelector) category = #'accessing'! !

!LazyRabbitModelTest methodsFor: 'method selectors' stamp: 'hjo 8/25/2009 22:19'!
testDefaultGeneratorSelector

	rabbit variableName: 'yy'.
	self assert: rabbit defaultGeneratorSelector = #defaultYy! !

!LazyRabbitModelTest methodsFor: 'method selectors' stamp: 'hjo 8/25/2009 22:19'!
testGetterSelector

	rabbit variableName: 'yy'.
	self assert: rabbit getterSelector = #yy! !

!LazyRabbitModelTest methodsFor: 'compiling source code' stamp: 'hjo 12/4/2011 23:16'!
testSetDefaultGeneratorSourceCodeNotAllowingEmptyOne

	rabbit setDefaultGeneratorSourceCodeNotAllowingEmptyOne: '^43-21'.
	self assert: rabbit expressionForDefaultGenerator = '^43-21'.
	
	rabbit setDefaultGeneratorSourceCodeNotAllowingEmptyOne: ''.
	self assert: rabbit expressionForDefaultGenerator =  'self shouldBeImplemented'! !

!LazyRabbitModelTest methodsFor: 'method selectors' stamp: 'hjo 8/25/2009 22:19'!
testSetterSelector

	rabbit variableName: 'yy'.
	self assert: rabbit setterSelector = #yy:! !

!LazyRabbitModelTest methodsFor: 'compiling source code' stamp: 'hjo 6/6/2010 18:29'!
testSourceCodeForCreatingDefaultGeneratorMethod 

	rabbit variableName: 'a'.
	self assert: rabbit sourceCodeForCreatingDefaultGeneratorMethod = 
 'defaultA

	"Return a default object for instance variable a."
	^self shouldBeImplemented'! !

!LazyRabbitModelTest methodsFor: 'compiling source code' stamp: 'hjo 8/26/2009 19:52'!
testSourceCodeForCreatingGetterMethod

	rabbit variableName: 'a'.
	self assert: rabbit sourceCodeForCreatingGetterMethod = 
 'a

	^a setDefault: #defaultA for: self withSetter: #a:'! !

!LazyRabbitModelTest methodsFor: 'compiling source code' stamp: 'hjo 8/26/2009 19:54'!
testSourceCodeForCreatingSetterMethod

	rabbit variableName: 'a'.
	self assert: rabbit sourceCodeForCreatingSetterMethod =
 'a: anObject
		
	a := anObject'! !

!LazyRabbitModelTest methodsFor: 'testing' stamp: 'hjo 8/26/2009 19:58'!
testVariableNameIsCorrect

	self deny: rabbit variableNameIsCorrect.
	rabbit variableName: 'a'.
	self assert: rabbit variableNameIsCorrect.
	rabbit variableName: ''.
	self deny: rabbit variableNameIsCorrect.
	rabbit variableName: 'a'.
	self assert: rabbit variableNameIsCorrect.
	rabbit variableName: nil.
	self deny: rabbit variableNameIsCorrect.
! !

!UndefinedObject methodsFor: '*LazyRabbit' stamp: 'hjo 9/20/2009 15:18'!
ifNilInitializeWith: initializingSelector in: anObject 

	| newObject |
	newObject := anObject perform: initializingSelector.
	self assert: [newObject notNil] description: 'Initialized but it''s still nil.'.
	"Make sure your initializingSelector sets anObject's instance variable."
	^newObject! !

!UndefinedObject methodsFor: '*LazyRabbit' stamp: 'hjo 4/18/2009 15:28'!
setDefault: defaultSymbol for: anObject withSetter: setter

	| default |
	default := anObject perform: defaultSymbol.
	anObject perform: setter with: default.
	^default! !

!Browser methodsFor: '*LazyRabbit' stamp: 'hjo 12/4/2011 11:17'!
createLazyRabbitVar

	LazyRabbitControlledByUser addInstVarAndMethodsTo: self selectedClass.! !

!Browser methodsFor: '*LazyRabbit' stamp: 'hjo 12/4/2011 11:21'!
createLazyRabbitVarWithDefaultCode
	
	LazyRabbitControlledByUser addInstVarAndMethodsWithDefaultCodeTo: self selectedClass.! !

!Browser methodsFor: '*LazyRabbit-class function' stamp: 'hjo 8/27/2009 13:33'!
shiftedClassListMenu: aMenu
	"Set up the menu to apply to the receiver's class list when the shift key is down"

	^ aMenu addList: #(
			-
			('unsent methods'			browseUnusedMethods	'browse all methods defined by this class that have no senders')
			('unreferenced inst vars'	showUnreferencedInstVars	'show a list of all instance variables that are not referenced in methods')
			('unreferenced class vars'	showUnreferencedClassVars	'show a list of all class variables that are not referenced in methods')
			('subclass template'			makeNewSubclass		'put a template into the code pane for defining of a subclass of this class')
			-
			('sample instance'			makeSampleInstance		'give me a sample instance of this class, if possible')
			('inspect instances'			inspectInstances			'open an inspector on all the extant instances of this class')
			('inspect subinstances'		inspectSubInstances		'open an inspector on all the extant instances of this class and of all of its subclasses')
			-
			('add all meths to current chgs'		addAllMethodsToCurrentChangeSet
																'place all the methods defined by this class into the current change set')
			('create inst var accessors'	createInstVarAccessors	'compile instance-variable access methods for any instance variables that do not yet have them')
			-
			('add lazy rabbit...'	createLazyRabbitVar	'adds lazy rabbit variable & accessors')
			('add lazy rabbit with default code...'	createLazyRabbitVarWithDefaultCode	'adds lazy rabbit variable & accessors')
			-
			('more...'					offerUnshiftedClassListMenu	'return to the standard class-list menu'))! !

Object subclass: #LazyRabbitController
	instanceVariableNames: 'userWantsToOverwriteGetter userWantsToOverwriteSetter userWantsToOverwriteDefaultGenerator userWantsToQuit model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LazyRabbit'!

LazyRabbitController subclass: #LazyRabbitControlledByUser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LazyRabbit'!

!LazyRabbitControlledByUser classSide methodsFor: 'as yet unclassified' stamp: 'hjo 12/4/2011 12:44'!
addInstVarAndMethodsTo: aClass

	self privateAddInstVarAndMethodsTo: aClass  subJob:  [:instance|]! !

!LazyRabbitControlledByUser classSide methodsFor: 'as yet unclassified' stamp: 'hjo 12/4/2011 23:41'!
addInstVarAndMethodsWithDefaultCodeTo: aClass

	self privateAddInstVarAndMethodsTo: aClass  subJob:  [:instance| 
		instance userWantsToQuit ifFalse: [
		instance setUserEnteredDefaultExpressionFromUser].]
! !

!LazyRabbitControlledByUser classSide methodsFor: 'as yet unclassified' stamp: 'hjo 12/4/2011 12:42'!
privateAddInstVarAndMethodsTo: aClass subJob: aBlock

	| instance |	
	instance := self new.
	instance model subjectClass: aClass.
	instance setVariableNameFromUser.
	aBlock value: instance.
	instance tryToCreateVariableAndMethods! !

!LazyRabbitControlledByUser methodsFor: 'overwriting' stamp: 'hjo 8/26/2009 12:12'!
overwriteDefaultGeneratorMethodIfUserWantsTo

	self userWantsToOverwriteDefaultGenerator: (self confirm: 'Default generator method already exists.
Do you want to overwrite it?').

	super overwriteDefaultGeneratorMethodIfUserWantsTo! !

!LazyRabbitControlledByUser methodsFor: 'overwriting' stamp: 'hjo 8/26/2009 12:11'!
overwriteGetterMethodIfUserWantsTo

	self userWantsToOverwriteGetter: (self confirm: 'Getter method already exists.
Do you want to overwrite it?').
	super overwriteGetterMethodIfUserWantsTo! !

!LazyRabbitControlledByUser methodsFor: 'overwriting' stamp: 'hjo 8/26/2009 12:09'!
overwriteSetterMethodIfUserWantsTo

	self userWantsToOverwriteSetter: (self confirm: 'Setter method already exists.
Do you want to overwrite it?').
	super overwriteSetterMethodIfUserWantsTo! !

!LazyRabbitControlledByUser methodsFor: 'user intervention' stamp: 'hjo 12/4/2011 11:09'!
setDefaultSourceFromUser

	| sourceFromUser |
	sourceFromUser := UIManager default
		request: 'Default Generator code'
		initialAnswer:  '^0'
		centerAt: Sensor cursorPoint.

	self model setDefaultGeneratorSourceCodeNotAllowingEmptyOne: sourceFromUser! !

!LazyRabbitControlledByUser methodsFor: 'user intervention' stamp: 'hjo 12/4/2011 12:23'!
setUserEnteredDefaultExpressionFromUser

	self userEnteredDefaultExpression: ( UIManager default 
 	    request: 'defalut value for the variable "' , self model variableName , '"'
 	    initialAnswer:  ''
    		centerAt: Sensor cursorPoint ).
! !

!LazyRabbitControlledByUser methodsFor: 'user intervention' stamp: 'hjo 12/4/2011 23:42'!
setVariableNameFromUser

	| newInstVarName |
	newInstVarName := UIManager default request:'new inst var name' initialAnswer:'' centerAt:Sensor cursorPoint.
	newInstVarName isNil ifTrue: [self userWantsToQuit: true].  
	self model variableName: newInstVarName! !

!LazyRabbitControlledByUser methodsFor: 'user intervention' stamp: 'hjo 12/4/2011 23:42'!
tryToProceedWhenTheVariableAlreadyExists
	
	self userWantsToQuit:  (self confirm: 'Variable "' , self model variableName , '" already exists. 
Do you want to continue?') not.
	super tryToProceedWhenTheVariableAlreadyExists! !

!LazyRabbitController methodsFor: 'main' stamp: 'hjo 8/27/2009 12:47'!
createAllMethodsForSubjectClass

	self model subjectClass instVarNames do: [:v| self model variableName: v. self tryToCreateVariableAndMethods ].! !

!LazyRabbitController methodsFor: 'defaults' stamp: 'hjo 8/25/2009 20:44'!
defaultModel

	"Return a default object for instance variable model."
	^LazyRabbitModel new! !

!LazyRabbitController methodsFor: 'defaults' stamp: 'hjo 12/4/2011 23:44'!
defaultUserWantsToQuit

	^false! !

!LazyRabbitController methodsFor: 'accessing' stamp: 'hjo 8/25/2009 20:44'!
model

	^model setDefault: #defaultModel for: self withSetter: #model:! !

!LazyRabbitController methodsFor: 'accessing' stamp: 'hjo 8/25/2009 20:44'!
model: anObject
		
	model := anObject! !

!LazyRabbitController methodsFor: 'default generator' stamp: 'hjo 12/4/2011 23:41'!
overwriteDefaultGeneratorMethodIfUserWantsTo

	self userWantsToQuit ifTrue: [^self].
	userWantsToOverwriteDefaultGenerator
		ifTrue: [ self model createDefaultGeneratorMethod ]! !

!LazyRabbitController methodsFor: 'getter' stamp: 'hjo 12/4/2011 23:41'!
overwriteGetterMethodIfUserWantsTo

	self userWantsToQuit ifTrue: [^self].
	userWantsToOverwriteGetter
		ifTrue: [ self model createGetterMethod ]! !

!LazyRabbitController methodsFor: 'setter' stamp: 'hjo 12/4/2011 23:41'!
overwriteSetterMethodIfUserWantsTo

	self userWantsToQuit ifTrue: [^self].
	userWantsToOverwriteSetter
		ifTrue: [ self model createSetterMethod ]! !

!LazyRabbitController methodsFor: 'default generator' stamp: 'hjo 12/4/2011 23:41'!
tryToCreateDefaultGeneratorMethod

	self userWantsToQuit ifTrue: [^self].
	self model subjectClassHasDefaultGenerator
		ifTrue: [ self overwriteDefaultGeneratorMethodIfUserWantsTo ]
		ifFalse: [ self model createDefaultGeneratorMethod ]! !

!LazyRabbitController methodsFor: 'getter' stamp: 'hjo 12/4/2011 23:41'!
tryToCreateGetterMethod

	self userWantsToQuit ifTrue: [^self].	
	self model subjectClassHasGetter
		ifTrue: [ self overwriteGetterMethodIfUserWantsTo ]
		ifFalse: [ self model createGetterMethod ]! !

!LazyRabbitController methodsFor: 'main' stamp: 'hjo 8/27/2009 12:37'!
tryToCreateMethods

	self tryToCreateSetterMethod.
	self tryToCreateDefaultGeneratorMethod.
	self tryToCreateGetterMethod! !

!LazyRabbitController methodsFor: 'setter' stamp: 'hjo 12/4/2011 23:41'!
tryToCreateSetterMethod

	self userWantsToQuit ifTrue: [^self].
	self model subjectClassHasSetter
		ifTrue: [ self overwriteSetterMethodIfUserWantsTo ]
		ifFalse: [ self model createSetterMethod ]! !

!LazyRabbitController methodsFor: 'main' stamp: 'hjo 12/4/2011 23:41'!
tryToCreateVariableAndMethods

	self userWantsToQuit ifTrue: [^self].  
	self model subjectClassHasInstanceVariableNamedVariableName
		ifTrue: [ self tryToProceedWhenTheVariableAlreadyExists ]
		ifFalse: [ 
			self model createInstanceVariable.
			self tryToCreateMethods
			]! !

!LazyRabbitController methodsFor: 'main' stamp: 'hjo 8/27/2009 12:40'!
tryToProceedWhenTheVariableAlreadyExists
	
	self tryToCreateMethods! !

!LazyRabbitController methodsFor: 'default generator' stamp: 'hjo 12/4/2011 11:54'!
userEnteredDefaultExpression: aByteString 

	self model defaultGeneratorSourceCode: (aByteString isEmpty ifTrue: [nil] ifFalse: [ aByteString  ])! !

!LazyRabbitController methodsFor: 'accessing' stamp: 'hjo 8/22/2009 16:57'!
userWantsToOverwriteDefaultGenerator: aBoolean

	userWantsToOverwriteDefaultGenerator := aBoolean! !

!LazyRabbitController methodsFor: 'accessing' stamp: 'hjo 8/21/2009 13:45'!
userWantsToOverwriteGetter: aBoolean

	userWantsToOverwriteGetter := aBoolean	! !

!LazyRabbitController methodsFor: 'accessing' stamp: 'hjo 8/21/2009 20:47'!
userWantsToOverwriteSetter: aBoolean

	userWantsToOverwriteSetter := aBoolean! !

!LazyRabbitController methodsFor: 'accessing' stamp: 'hjo 12/4/2011 23:44'!
userWantsToQuit

	^userWantsToQuit setDefault: #defaultUserWantsToQuit for: self withSetter: #userWantsToQuit:! !

!LazyRabbitController methodsFor: 'accessing' stamp: 'hjo 12/4/2011 23:42'!
userWantsToQuit: aBoolean

	userWantsToQuit := aBoolean
	! !

Object subclass: #LazyRabbitModel
	instanceVariableNames: 'subjectClass variableName defaultGeneratorSourceCode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LazyRabbit'!

!LazyRabbitModel methodsFor: 'compiling' stamp: 'hjo 8/27/2009 11:04'!
compileAsAccessing: sourceString

	subjectClass compile: sourceString
			classified: 'accessing' notifying: nil! !

!LazyRabbitModel methodsFor: 'compiling' stamp: 'hjo 8/27/2009 11:03'!
compileAsDefaults: sourceString

	subjectClass compile: sourceString
			classified: 'defaults' notifying: nil! !

!LazyRabbitModel methodsFor: 'compiling' stamp: 'hjo 12/4/2011 23:05'!
createDefaultGeneratorMethod

	self compileAsDefaults: self sourceCodeForCreatingDefaultGeneratorMethod! !

!LazyRabbitModel methodsFor: 'compiling' stamp: 'hjo 8/27/2009 11:05'!
createGetterMethod

	self compileAsAccessing: self sourceCodeForCreatingGetterMethod! !

!LazyRabbitModel methodsFor: 'compiling' stamp: 'hjo 6/1/2011 23:21'!
createInstanceVariable

	subjectClass addInstVarNamed: variableName! !

!LazyRabbitModel methodsFor: 'compiling' stamp: 'hjo 8/27/2009 11:05'!
createSetterMethod

	self compileAsAccessing: self sourceCodeForCreatingSetterMethod! !

!LazyRabbitModel methodsFor: 'defaults' stamp: 'hjo 8/25/2009 20:49'!
defaultDefaultGeneratorSourceCode

	"Return a default object for instance variable defaultGeneratorSourceCode."
	^'self shouldBeImplemented'! !

!LazyRabbitModel methodsFor: 'method selectors' stamp: 'hjo 8/25/2009 21:20'!
defaultGeneratorSelector

	^('default' , variableName capitalized) asSymbol! !

!LazyRabbitModel methodsFor: 'accessing' stamp: 'hjo 8/25/2009 20:49'!
defaultGeneratorSourceCode: aString
		
	defaultGeneratorSourceCode := aString! !

!LazyRabbitModel methodsFor: 'accessing' stamp: 'hjo 12/4/2011 23:16'!
expressionForDefaultGenerator

	^defaultGeneratorSourceCode setDefault: #defaultDefaultGeneratorSourceCode for: self withSetter: #defaultGeneratorSourceCode:! !

!LazyRabbitModel methodsFor: 'method selectors' stamp: 'hjo 8/25/2009 21:20'!
getterSelector

	^variableName asSymbol! !

!LazyRabbitModel methodsFor: 'accessing source code' stamp: 'hjo 12/4/2011 23:16'!
setDefaultGeneratorSourceCodeNotAllowingEmptyOne: aByteString 

	self defaultGeneratorSourceCode: aByteString.
	self expressionForDefaultGenerator isEmpty ifTrue: [ self defaultGeneratorSourceCode: nil ]! !

!LazyRabbitModel methodsFor: 'method selectors' stamp: 'hjo 8/25/2009 21:20'!
setterSelector

	^(variableName , ':') asSymbol! !

!LazyRabbitModel methodsFor: 'compiling source code' stamp: 'hjo 12/4/2011 23:16'!
sourceCodeForCreatingDefaultGeneratorMethod 

	^'default', variableName capitalized , '

	"Return a default object for instance variable ',variableName,'."
	^', self expressionForDefaultGenerator! !

!LazyRabbitModel methodsFor: 'compiling source code' stamp: 'hjo 8/25/2009 21:21'!
sourceCodeForCreatingGetterMethod
	
	^variableName ,
'

	^',variableName,' setDefault: #default', variableName capitalized ,' for: self withSetter: #',variableName,':'! !

!LazyRabbitModel methodsFor: 'compiling source code' stamp: 'hjo 8/25/2009 21:22'!
sourceCodeForCreatingSetterMethod

	^variableName ,': anObject
		
	',variableName,' := anObject'! !

!LazyRabbitModel methodsFor: 'accessing source code' stamp: 'hjo 8/27/2009 11:10'!
sourceCodeOfDefaultGeneratorMethod

	^(subjectClass sourceCodeAt: self defaultGeneratorSelector) asString! !

!LazyRabbitModel methodsFor: 'accessing source code' stamp: 'hjo 8/27/2009 11:09'!
sourceCodeOfGetterMethod

	^(subjectClass sourceCodeAt: self getterSelector) asString! !

!LazyRabbitModel methodsFor: 'accessing source code' stamp: 'hjo 8/27/2009 11:09'!
sourceCodeOfSetterMethod

	^(subjectClass sourceCodeAt: self setterSelector) asString! !

!LazyRabbitModel methodsFor: 'accessing' stamp: 'hjo 8/26/2009 10:37'!
subjectClass

	^subjectClass! !

!LazyRabbitModel methodsFor: 'accessing' stamp: 'hjo 8/25/2009 20:54'!
subjectClass: aClass 

	subjectClass := aClass ! !

!LazyRabbitModel methodsFor: 'testing' stamp: 'hjo 9/5/2009 14:18'!
subjectClassHasDefaultGenerator

	^subjectClass selectors includes: self defaultGeneratorSelector! !

!LazyRabbitModel methodsFor: 'testing' stamp: 'hjo 8/25/2009 20:54'!
subjectClassHasGetter

	^subjectClass selectors includes: self getterSelector! !

!LazyRabbitModel methodsFor: 'testing' stamp: 'hjo 9/5/2009 14:18'!
subjectClassHasInstanceVariableNamedVariableName
	
	^subjectClass instVarNames includes: variableName! !

!LazyRabbitModel methodsFor: 'testing' stamp: 'hjo 8/25/2009 20:54'!
subjectClassHasSetter

	^subjectClass selectors includes: self setterSelector! !

!LazyRabbitModel methodsFor: 'accessing' stamp: 'hjo 8/27/2009 00:09'!
variableName

	^variableName! !

!LazyRabbitModel methodsFor: 'accessing' stamp: 'hjo 8/25/2009 21:25'!
variableName: aByteString 

	variableName := aByteString ! !

!LazyRabbitModel methodsFor: 'testing' stamp: 'hjo 8/25/2009 21:23'!
variableNameIsCorrect

	^variableName notNil and: [variableName size > 0]! !

!Object methodsFor: '*LazyRabbit' stamp: 'hjo 9/20/2009 15:04'!
ifNilInitializeWith: initializingSelector in: anObject

	"no need to initialize."
	^self! !

!Object methodsFor: '*LazyRabbit' stamp: 'hjo 4/18/2009 15:28'!
setDefault: defaultSymbol for: anObject withSetter: setter

	"I am not nil, so do nothing."
	^self! !
